VERSION 5.00
Begin VB.Form frmResize 
   Caption         =   "Current size is width:8, height:8"
   ClientHeight    =   3255
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4695
   LinkTopic       =   "Form1"
   ScaleHeight     =   3255
   ScaleWidth      =   4695
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picImgSet 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   1095
      Left            =   2160
      ScaleHeight     =   73
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   81
      TabIndex        =   10
      Top             =   120
      Visible         =   0   'False
      Width           =   1215
      Begin VB.PictureBox picWhite 
         AutoRedraw      =   -1  'True
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'None
         Height          =   960
         Left            =   120
         ScaleHeight     =   64
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   64
         TabIndex        =   11
         Top             =   120
         Width           =   960
      End
   End
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   495
      Left            =   1680
      TabIndex        =   9
      Top             =   2640
      Width           =   1215
   End
   Begin VB.CommandButton cmdReset 
      Caption         =   "Reset"
      Height          =   615
      Left            =   3120
      TabIndex        =   8
      Top             =   1320
      Width           =   615
   End
   Begin VB.TextBox txtHeight 
      Height          =   285
      Left            =   1800
      TabIndex        =   5
      Top             =   1680
      Width           =   1215
   End
   Begin VB.TextBox txtWidth 
      Height          =   285
      Left            =   1800
      TabIndex        =   4
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton cmdResize 
      Height          =   1095
      Index           =   3
      Left            =   3480
      MaskColor       =   &H00FF00FF&
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   2040
      UseMaskColor    =   -1  'True
      Width           =   1095
   End
   Begin VB.CommandButton cmdResize 
      Height          =   1095
      Index           =   2
      Left            =   120
      MaskColor       =   &H00FF00FF&
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   2040
      UseMaskColor    =   -1  'True
      Width           =   1095
   End
   Begin VB.CommandButton cmdResize 
      Height          =   1095
      Index           =   1
      Left            =   3480
      MaskColor       =   &H00FF00FF&
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   120
      UseMaskColor    =   -1  'True
      Width           =   1095
   End
   Begin VB.CommandButton cmdResize 
      Height          =   1095
      Index           =   0
      Left            =   120
      MaskColor       =   &H00FF00FF&
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   120
      UseMaskColor    =   -1  'True
      Width           =   1095
   End
   Begin VB.Image imgButtonPics 
      Height          =   960
      Index           =   0
      Left            =   1320
      Top             =   120
      Visible         =   0   'False
      Width           =   960
   End
   Begin VB.Label lblHeight 
      Alignment       =   1  'Right Justify
      Caption         =   "New height:"
      Height          =   255
      Left            =   480
      TabIndex        =   7
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Label lblWidth 
      Alignment       =   1  'Right Justify
      Caption         =   "New width:"
      Height          =   255
      Left            =   480
      TabIndex        =   6
      Top             =   1320
      Width           =   1215
   End
End
Attribute VB_Name = "frmResize"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdDone_Click()
Dim w As Integer, h As Integer

    On Local Error GoTo numerr
    w = CInt(txtWidth.Text)
    h = CInt(txtHeight.Text)
    If w <> intCols Or h <> intRows Then
        If MsgBox("You have made changes since you last applyed, are you sure you want to leave?", vbYesNo) = vbNo Then Exit Sub
    End If

numerr:
    frmResize.Hide
End Sub

Private Sub cmdReset_Click()

    txtHeight.Text = intRows
    txtWidth.Text = intCols

End Sub

Private Sub cmdResize_Click(Index As Integer)
Dim cTemp As Integer, rTemp As Integer
Dim levelTemp() As Integer
Dim i As Integer, j As Integer, l As Integer
Dim rowOffset As Integer, colOffset As Integer
Dim entsRemoved As Integer

    On Local Error GoTo numerr
    cTemp = CInt(txtWidth.Text)
    rTemp = CInt(txtHeight.Text)
    If cTemp <= 0 Or rTemp <= 0 Then GoTo numerr
    If Index = 0 Or Index = 2 Then colOffset = cTemp - intCols Else colOffset = 0
    If Index = 0 Or Index = 1 Then rowOffset = rTemp - intRows Else rowOffset = 0

    ReDim levelTemp(4, cTemp - 1, rTemp - 1)
    For l = 0 To 4
        For i = 0 To cTemp - 1
            For j = 0 To rTemp - 1
                If 0 <= i - colOffset And i - colOffset < intCols And 0 <= j - rowOffset And j - rowOffset < intRows Then
                    levelTemp(l, i, j) = intLevel(l, i - colOffset, j - rowOffset)
                Else
                    If l = 0 Then levelTemp(l, i, j) = 0 Else levelTemp(l, i, j) = -1
                End If
            Next j
        Next i
    Next l
    intLevel = levelTemp

    If intEntityCount > 0 Then
        entsRemoved = 0
        For i = 0 To intEntityCount - 1
            intEntities(1, i) = intEntities(1, i) + colOffset
            intEntities(2, i) = intEntities(2, i) + rowOffset
            If intEntities(1, i) < 0 Or intEntities(1, i) >= cTemp Or intEntities(2, i) < 0 Or intEntities(2, i) >= rTemp Then
                entsRemoved = entsRemoved + 1
            ElseIf entsRemoved > 0 Then
                For j = 0 To 3
                    intEntities(j, i - entsRemoved) = intEntities(j, i)
                Next j
                strEntityData(i - entsRemoved) = strEntityData(i)
            End If
        Next i
        intEntityCount = intEntityCount - entsRemoved
        If intEntityCount > 0 Then
            ReDim Preserve intEntities(3, intEntityCount - 1)
            ReDim Preserve strEntityData(intEntityCount - 1)
        End If
    End If

    intCols = cTemp
    intRows = rTemp

    frmMain.prcDrawTiles
    frmMain.Form_Resize
    txtWidth_Change
    changesMade = True

    Exit Sub
numerr:
    MsgBox "On1y pu7 p0sit1f numb3r5 in teh box0rz plx" & vbCrLf & vbCrLf & "                      kthxbye"
End Sub

Private Sub Form_Activate()
Dim i As Integer

    txtWidth.Text = intCols
    txtHeight.Text = intRows
    frmResize.Caption = "Current size is width:" & intCols & " , height:" & intRows

    For i = 0 To 3
        cmdResize(i).Picture = imgButtonPics(16 + i).Picture
    Next i

End Sub

Private Sub Form_Load()
Dim i As Integer, j As Integer

    picImgSet.Picture = LoadPicture("resize.bmp")

    For i = 0 To 8
        For j = 0 To 3
            If i + j > 0 Then Load imgButtonPics(4 * i + j)
            picWhite.Cls
            picWhite.PaintPicture picImgSet.Image, 0, 0, 64, 64, j * 64, i * 64, 64, 64
            imgButtonPics(4 * i + j).Picture = picWhite.Image
'            imgButtonPics(4 * i + j).Left = imgButtonPics(0).Left + 1005 * j
'            imgButtonPics(4 * i + j).Top = imgButtonPics(0).Top + 1005 * i
'            imgButtonPics(4 * i + j).Visible = True
        Next j
    Next i

End Sub

Private Sub txtHeight_Change()

    txtWidth_Change

End Sub

Private Sub txtWidth_Change()
Dim w As Integer, h As Integer
Dim i As Integer, j As Integer

    On Local Error GoTo numerr
    w = CInt(txtWidth.Text)
    h = CInt(txtHeight.Text)
    If w <= 0 Or h <= 0 Then GoTo numerr

    j = 16 + 4 * Sgn(intCols - w) + 12 * Sgn(intRows - h)
    For i = 0 To 3
        cmdResize(i).Enabled = True
        cmdResize(i).Picture = imgButtonPics(i + j).Picture
    Next i

    Exit Sub
numerr:
    For i = 0 To 3
        cmdResize(i).Enabled = False
    Next i
End Sub
